package gonganxitong

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/gonganxitong/model"
)

type paymentlist struct {
	Table
	order  string `data:"92"`
	fields string `data:"user_uid,paymentlist_status,amount,title,content"`
	create string `name:"create amount* title* content" role:"leader"`
	payfor string `name:"payfor" help:"支付" style:"notice" role:"void"`
}

func (s paymentlist) List(m *ice.Message, arg ...string) {
	s.ValueList(m, arg).Table(func(value ice.Maps) {
		switch PaymentStatus(kit.Int(value[model.PAYMENTLIST_STATUS])) {
		case PaymentCreate:
			m.PushButton(s.Payfor)
		case PaymentSuccess:
			m.PushButton()
		default:
			m.PushButton()
		}
	}).Display("")
	s.SelectJoinUser(m)
}
func (s paymentlist) Payfor(m *ice.Message, arg ...string) {
	s.cmdy(m, s.Request, arg...)
}
func (s paymentlist) Request(m *ice.Message, arg ...string) {}
func (s paymentlist) Response(m *ice.Message, arg ...string) {
	if len(arg) > 1 {
		s.Update(m, kit.Dict(model.STATUS, PaymentSuccess), s.PLACE_UID, arg[0], model.UID, arg[1])
	}
}

func init() { ice.TeamCtxCmd(paymentlist{Table: newTable()}) }

func (s paymentlist) cmdy(m *ice.Message, action ice.Any, arg ...string) {
	m.Options(model.PLACE_UID, m.Option(s.PLACE_UID)).Cmdy(paymentVendorKey, action, arg)
}

type PaymentStatus int

const (
	PaymentCreate PaymentStatus = iota
	PaymentSuccess
	PaymentFailure
)

var PaymentStatusList = map[PaymentStatus]string{
	PaymentCreate:  "create",
	PaymentSuccess: "success",
	PaymentFailure: "failure",
}

func (s PaymentStatus) String() string { return PaymentStatusList[s] }

type PaymentVendor interface {
	Request(m *ice.Message, arg ...string) *ice.Message
}

var paymentVendorKey string
var paymentVendorList = map[string]PaymentVendor{}

func PaymentVendorAdd(key string, vendor PaymentVendor) {
	paymentVendorKey, paymentVendorList[key] = key, vendor
}
